using System.Runtime.InteropServices;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace CSharpTest
{
    public partial class Form1 : Form
    {
        
        [DllImport("LL_USB2k.dll")] public static extern byte EX_Connect(ushort[] usDevID);
        [DllImport("LL_USB2k.dll")]public static extern byte EX_SetPolledModeChan(ushort usDevID, byte bChan);
        [DllImport("LL_USB2k.dll")] public static extern byte EX_GetOneConversion(ushort usDevID, double[] pdblMilliVolts);
        [DllImport("LL_USB2k.dll")] public static extern byte EX_Run(ushort usDevID);
        [DllImport("LL_USB2k.dll")] public static extern byte EX_Stop(ushort usDevID);
        [DllImport("LL_USB2k.dll")] public static extern byte EX_StopComplete(ushort usDevID);
        [DllImport("LL_USB2k.dll")] public static extern byte EX_SendDigout(ushort usDevID, byte bDigOut);
        [DllImport("LL_USB2k.dll")] public static extern byte EX_GetDigin(ushort usDevID, byte[] pbDigIn);

        public Form1() { InitializeComponent(); }
        private void btnSetCOM_Click(object sender, EventArgs e)
        {
            Byte bRetVal; Byte bPort = (byte)byte.Parse(txtPort.Text);
           // bRetVal = EX_SetCOMport(bPort);
        }

        private void Form1_Load(object sender, EventArgs e)
        {
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Byte bRetVal;
            ushort[] usDevID = new ushort[1];
            bRetVal = EX_Connect(usDevID);
            if (bRetVal == 1) txtDevID.Text = string.Format("{0:D}", usDevID[0]); 

            return;
            
            label10.Visible = true;
            textBox7.Text = "please wait - -  -   -   -"; Update();
            //byte bRetVal = 0;
            //bRetVal = EX_SetScanType(1);
            if (bRetVal == 0)
            { textBox7.Text = "failed EX_SetScanType"; label10.Visible = false; return; }
            textBox7.Text = "succeeded EX_SetScanType";
            textBox7.Text = "wait ---";
            //bRetVal = EX_SetDataLogOptions(7, 0, 0);
            if (bRetVal == 0)
            { textBox7.Text = "failed EX_SetDataLogOptions"; label10.Visible = false; return; }
            textBox7.Text = "succeeded EX_SetDataLogOptions";
            textBox7.Text = "wait ---";
            //scan main chan-0(no sub), main chan-1(sub chans 0,1,2)
            //bRetVal = EX_SetMultiChanScanChanCodes(0, 2, 16, 16, 16, 16, 0);
            if (bRetVal == 0)
            { textBox7.Text = "failed EX_SetMultiChanScanChanCodes"; label10.Visible = false; return; }
            textBox7.Text = "succeeded EX_SetMultiChanScanChanCodes"; label10.Visible = false;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            label10.Visible = true;
            textBox7.Text = "please wait - -  -   -   -"; Update();
            byte bRetVal = 0;
            //bRetVal = EX_Run();
            if (bRetVal == 0)
            { textBox7.Text = "failed EX_Run"; label10.Visible = false; return; }
            textBox7.Text = "succeeded EX_Run"; label10.Visible = false;
        }
        private void button3_Click(object sender, EventArgs e)
        {
            label10.Visible = true;
            textBox7.Text = "please wait - -  -   -   -"; Update();
            byte bRetVal = 0;
            double[] dataBuff = new double[4];
            uint[] numScansReturned = new uint[1]; numScansReturned[0] = 0;
            uint[] numScansInBuff = new uint[1];
            byte[] scanRunning = new byte[1]; scanRunning[0] = 0;
            //bRetVal = EX_GetScanDataDbl(dataBuff, 1, numScansReturned, numScansInBuff, scanRunning);
            
            
            //bRetVal = EX_GetScanDataDbl(dataBuff, 0, numScansReturned, numScansInBuff, scanRunning);
            if(numScansInBuff[0]==0)
            { textBox7.Text = "no scans in buffer"; label10.Visible = false; return; }
            //bRetVal = EX_GetScanDataDbl(dataBuff, 1, numScansReturned, numScansInBuff, scanRunning);



            if (bRetVal == 0)
            { textBox7.Text = "failed EX_GetScanDataDbl"; label10.Visible = false; return; }
            textBox7.Text = "succeeded EX_GetScanDataDbl";
            textBox10.Text = string.Format("{0}", numScansReturned[0]);
            textBox11.Text = string.Format("{0}", numScansInBuff[0]);
            textBox12.Text = string.Format("{0}", scanRunning[0]);
            if (numScansReturned[0] == 1)
            {
                textBox8.Text = string.Format("{0:f6}", dataBuff[0]);
                textBox9.Text = string.Format("{0:f6}", dataBuff[1]);
                textBox1.Text = string.Format("{0:f6}", dataBuff[2]);
                textBox2.Text = string.Format("{0:f6}", dataBuff[3]);
            } label10.Visible = false;
        }
        private void button4_Click(object sender, EventArgs e)
        {
            label10.Visible = true;
            textBox7.Text = "please wait - -  -   -   -"; Update();
            byte bRetVal = 0;
            //bRetVal = EX_Stop();
            if (bRetVal == 0)
            { textBox7.Text = "failed EX_Stop"; label10.Visible = false; return; }
            textBox7.Text = "succeeded EX_Stop"; label10.Visible = false;
        }
    }
}




